# This program was made as part of the sk1project activity to improve UniConvertor
# See http://www.sk1project.org
#
# The code of vsview based on the results of the ALT Linux vsdump project.
# See www.altlinux.ru and http://freshmeat.net/projects/vsdump
#
# Copyright (C) 2007,	Valek Filippov (frob@df.ru)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 3 or later of the GNU General Public
# License as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
# USA

import vsdoc
import math
import gtk
import pango
import cairo
import draw2
import struct
import mfpage
import emfdoc
import wmfdoc

def MoveTo(context,shape,args):
    context.move_to(args[0],-args[1])
##    print 'Cmd MoveTo ',args
    
def LineTo(context,shape,args):
    context.line_to(args[0],-args[1])
##    print 'Cmd LineTo ',args

def PolylineTo(context,shape,args):
##    context.line_to(args[0],-args[1])
    print 'Cmd PolylineTo ',args
    
def ArcTo(context,shape,args):
    flag = 0
    x1,y1 = context.get_current_point()
    x= args[0]
    y= -args[1]
    a= args[2]
    radius = (4.*a*a+(x-x1)**2+(y-y1)**2)/(8.*a)
    len = radius - a
    if a < 0:
        radius = -radius
    k = (x - x1)/(y1 - y)
    xa = (x+x1)/2.
    ya = (y+y1)/2.
    alfa = math.atan(k)
    if y1>y:
        len = -len
    xc = xa + len*math.cos(alfa)
    yc = ya + len*math.sin(alfa)
    ang1 = math.atan2((y1-yc),(x1-xc))
    ang2 = math.atan2((y-yc),(x-xc)) # for arc2 and arc3
    if a > 0:
        context.arc_negative(xc, yc, radius, ang1, ang2)
    else:
            context.arc(xc, yc, radius, ang1, ang2)
##    print 'Cmd ArcTo: from %.2f %.2f to %.2f %.2f bow %.2f'%(x1,y1,x,y,a)
##    print 'Center: %.2f %.2f Radius: %.2f Angles: %.2f %.2f'%(xc,yc,radius,180*ang1/math.pi,180*ang2/math.pi)

def EllipticalArcTo(context,shape,args):
    draw2.EllipticalArcTo(context,shape,args)
    
def Ellipse(context,shape,args):
    x = args[0]
    y = args[1]
    a = args[2]
    b = args[3]
    d = args[5]
    context.move_to(x,-y)
    context.save()
    context.translate(x,-y)
    context.move_to((a-x), (b-y))
    context.scale((a-x), (d-y))
    context.arc(0.,0.,1.,0.,2.0*math.pi)
    context.move_to(x, -y)
    context.restore()
##    print 'Cmd Ellipse ',args

drawcmd = {'MoveTo':MoveTo, 'LineTo':LineTo,'ArcTo':ArcTo, 'Ellipse':Ellipse,'PolylineTo':PolylineTo,'EllipticalArcTo':EllipticalArcTo,'Foreign':draw2.frgn_draw}

def render3(doc,page,shape,context,xflag):
    fgcolor = shape.fill.fgcolor
    bgcolor = shape.fill.bgcolor
    if shape.fill.set == 0:
        bgcolor.r = 255
        bgcolor.g = 255
        bgcolor.b = 255
    lineclr = shape.line.lineclr
    linewidth = shape.line.width
    if shape.line.pattern == 0:
        linewidth = 0
    context.set_line_width(linewidth)

    xform = shape.xform
    x = xform.x
    y = page.height-xform.y
    h = xform.h
    w = xform.w
    locx = xform.locx
    locy = xform.locy
    flipx = xform.flipx
    flipy = xform.flipy
    ang = xform.ang
    print 'Xform.ang:',ang
#    print 'XForm X/Y/W/H/LX/LY/Ang: %u %u %u %u %u %u %.2f'%(x,y,w,h,locx,locy,180*ang/3.1415926),'xflag:',xflag

    context.save()
    if xflag == 0:
        matrix = cairo.Matrix(1,0,0,1,0,0)
        context.translate(x-locx,y+locy) 
    if xflag == 2:
        matrix = cairo.Matrix(1,0,0,1,0,0)
        context.translate(x-locx,y+locy-page.height) 
    fx,fy = 1,1
    if flipx:
        fx = -1
    if flipy:
        fy = -1
    
    if ang != 0 or flipx or flipy:
        context.save()
        if ang != 0:
            c = math.cos(-ang)
            s = math.sin(-ang)
            cx = locx
            cy = -locy
            mtrx = cairo.Matrix(fx*c,fx*s,-s*fy,c*fy,c*locx*(1-fx)-s*locy*(fy-1)+cx-c*cx+s*cy,s*locx*(1-fx)+c*locy*(fy-1)+cy-s*cx-c*cy)
        else:
            mtrx = cairo.Matrix(fx,0,0,fy,locx-locx*fx,locy*fy-locy)    
        context.transform(mtrx)
    
    if shape.type == 0x48: ## Shape == Shape
        context.save()
        draw2.shape(doc,page,shape,context,xflag)
        context.restore()
        
    if shape.type  == 0x47: ## Shape == Group
        draw2.group(doc,page,shape,context,xflag)
        
    if shape.type == 0x4e: ## Shape == Foreign       
        context.save()
        draw2.foreign(doc,page,shape,context,xflag)
        context.restore()

    if flipx or flipy:
        if ang!=0:
            context.restore()
            context.save()
            mtrx = cairo.Matrix(c,s,-s,c,cx-c*cx+s*cy,cy-s*cx-c*cy)
            context.transform(mtrx)
        else:
            context.restore()
        
    if shape.text:
        draw2.text(doc,page,shape,context,xflag)

    if ang != 0: ## if flipx or flipy !=1 than context always restored before text
        context.restore()
    context.restore()
