# This program was made as part of the sk1project activity to improve UniConvertor
# See http://www.sk1project.org
#
# The code of vsview based on the results of the ALT Linux vsdump project.
# See www.altlinux.ru and http://freshmeat.net/projects/vsdump
#
# Copyright (C) 2007,	Valek Filippov (frob@df.ru)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 3 or later of the GNU General Public
# License as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
# USA

import vsdoc
import math
import gtk
import struct
import pango
import cairo
import draw
import mfpage
import emfdoc
import wmfdoc


def EllipticalArcTo(context,shape,args):
    ecc = args[5] #eccentrisitet
    x3 = args[0] #3rd point X
    ye = args[1] #3rd point Y
    x2 = args[2] #2nd point X
    ym = args[3] #2nd point Y
    ang = args[4] #angle
##    print 'Cmd EllipticalArcTo ',args
    
    x1,ys = context.get_current_point()
    y1 = ys*ecc
#    y2 = ys+(ym-ys)*ecc*(x2-x1)/(x3-x1)
    y2 = -ym*ecc
    y3 = -ye*ecc
    
    ka = (y2-y1)/(x2*1.-x1)
    kb = (y3-y2)/(x3*1.-x2)

##    print 'ka, kb: ',ka,kb
    
    if ka-kb == 0:
        # line
        context.line_to(x3,y3)
    else:
        xr = 0.5*(ka*(kb*y3+x3+x2)-kb*(ka*y1+x1+x2))/(ka-kb)
    if ka != 0:
        yr = (y1+y2)/2.+((x2+x1)/2.-xr)/ka
    else:
        yr = (y2+y3)/2.+((x3+x2)/2.-xr)/kb
    

##    print 'x1,y1: ',x1,y1
##    print 'x2,y2: ',x2,y2
##    print 'x3,y3: ',x3,y3
##    print 'ang,ecc: %.2f %.2f'%(ang*180/math.pi,ecc)
    
    rad = ((x3-xr)**2+(y3-yr)**2)**0.5 #!@
    ang1 = math.atan2(yr-y1,x1-xr)
    ang2 = math.atan2(yr-y2,x2-xr)
    ang3 = math.atan2(yr-y3,x3-xr)

    
    square = 0.5*(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2))
    if square > 0:
        flag = 1
    else:
        flag = 0
##    print 'Center: %u %u Radius %u'%(xr,yr,rad)
##    print 'Angles: ',ang1*180/math.pi,ang2*180/math.pi, ang3*180/math.pi
    
    context.save()
    context.rotate(ang)
    context.scale(1,1/ecc)
##    context.move_to(x1,y1)
    if flag == 1:
        context.arc(xr, yr, rad, -ang1, -ang3)
    else:
        context.arc_negative(xr, yr, rad, -ang1, -ang3)
    context.restore()

    
##---------------------------------------------------##
## Type 1 formats:
## 0 -- bmp
## 1 -- jpg
## 2 -- gif
## 3 -- tif
## 4 -- png
## Type 2 -- OLE
## Type 4 -- wmf or emf
def frgn_draw(context,shape,version):
    if shape.Foreign.Type == 4 or (shape.Foreign.Type == 0 and shape.Foreign.Subtype == 8):
        if len(shape.Foreign.Data)>44:
            [sig] = struct.unpack('<L', shape.Foreign.Data[40:44])
            if sig == 0x464D4520:
                print 'EMF'
                page = mfpage.emfPage()
                scale = 1
            else:
                page = mfpage.wmfPage()
                scale = 1
                print 'WMF'
            page.file.loadmem(str(shape.Foreign.Data))
            page.parse()
            nums = len(page.cmds)
            page.hadj = 1
            pf = page.Face
            idx = 0
            for i in range(nums):
                spct = page.cmds[i].type
                if spct == 523:
                    page.DCs[0].x,page.DCs[0].y = page.cmds[i].args
                    idx+=1
                if spct == 524:
                    page.DCs[0].Wx,page.DCs[0].Wy = page.cmds[i].args
                    idx+=1
                if idx == 2:
                    page.width = abs(page.DCs[0].Wx) ##- self.page.DCs[0].x)
                    page.height = abs(page.DCs[0].Wy) ##- self.page.DCs[0].y)
                    break
            w = shape.xform.w
            h = shape.xform.h
            print 'Page WxH: %u %u. Shape WxH: %u %u.'%(page.width,page.height,w,h)
            if scale:
                frgnscalex = w/page.width
                frgnscaley = h/page.height
            else:
                frgnscalex = w*.2/page.width
                frgnscaley = h*.2/page.height
            context.save()
            context.translate(0,-h)
            context.scale(frgnscalex,frgnscaley)
            ct = gtk.gdk.CairoContext(context)
            pf.render(ct,pf.page)
            context.restore()
        else:
            print 'WARNING!!! Small ForeignData!'
        return
            
    if shape.Foreign.Type == 1:
        data = shape.Foreign.Data
        if version == 6:
            flen = len(data)+14
            [shift] = struct.unpack('<L',data[20:24])
            if shift:
                hex = flen - shift
            else:
                hex = 0x36
            flen = struct.pack('<I', flen)
            hex = struct.pack('<I', hex)
            header = 'BM'+ flen + '\x00\x00\x00\x00'+hex
            data = header + data
            
        f = open('preview.jpg','w')
        f.write(data)
        f.flush()
        f.close()
            
#        pixbufloader = gtk.gdk.PixbufLoader()
#        t1 = pixbufloader.write(data)
#        print 'PixBuf',t1
#        pixbufloader.close()
#        pixbuf = pixbufloader.get_pixbuf()
        pixbuf = gtk.gdk.pixbuf_new_from_file('preview.jpg')
        imgw=pixbuf.get_width()
        imgh=pixbuf.get_height()
        w = shape.xform.w
        h =shape.xform.h
        scalex = imgw/w
        scaley = imgh/h
        context.save()
        context.translate(0,-h)
        context.scale(1./scalex,1./scaley)
        ct = gtk.gdk.CairoContext(context)
        ct.set_source_pixbuf(pixbuf,0,0)
        context.paint()
        context.restore()

def shape(doc,page,shape,context,xflag):
        fgcolor = shape.fill.fgcolor
        bgcolor = shape.fill.bgcolor
        if shape.fill.set == 0:
            bgcolor.r = 255
            bgcolor.g = 255
            bgcolor.b = 255
        lineclr = shape.line.lineclr
        linewidth = shape.line.width
        if shape.line.pattern == 0:
            linewidth = 0
        context.set_line_width(linewidth)
        if shape.Foreign.stflag == 0:
            xs,ys = context.get_current_point()
            for j in range(len(shape.geom.cmds)):
                cmd = shape.geom.cmds[j]
                draw.drawcmd[cmd.type](context,shape,cmd.args)
            xe,ye = context.get_current_point()
            if math.fabs(xs-xe)<0.1 and math.fabs(ys-ye)<0.1:
                context.close_path()
            if shape.geom.nofill == 0:
                context.set_source_rgba(fgcolor.r/255.0,fgcolor.g/255.0,fgcolor.b/255.0,fgcolor.a)
                context.fill_preserve()
            if shape.geom.noline == 0:
                context.set_source_rgba(lineclr.r/255.0,lineclr.g/255.0,lineclr.b/255.0,1)
                context.stroke()
        else:
            Stencil = doc.stmap[shape.Foreign.Stencil]
            if shape.fill.set == 0:
                shape.fill = doc.stencils[Stencil-1].shapes[1].fill
                shape.geom.nofill = doc.stencils[Stencil-1].shapes[1].geom.nofill
                shape.geom.noline = doc.stencils[Stencil-1].shapes[1].geom.noline
                shape.geom.noshow = doc.stencils[Stencil-1].shapes[1].geom.noshow
                shape.geom.nosnap = doc.stencils[Stencil-1].shapes[1].geom.nosnap
            if len(shape.geom.cmds)==0:
                shape.geom.cmds=doc.stencils[Stencil-1].shapes[1].geom.cmds
            if shape.text.txt == '':
                shape.text =doc.stencils[Stencil-1].shapes[1].text
            xs,ys = context.get_current_point()
            if shape.xform1d:
                x = shape.xform.x
                y = shape.xform.y
                locx = shape.xform.locx
                locy = shape.xform.locy
                draw.drawcmd[shape.geom.cmds[0].type](context,shape,shape.geom.cmds[0].args)
                for j in range(len(shape.geom.cmds)-2):
                    cmd = shape.geom.cmds[j+2]
                    draw.drawcmd[cmd.type](context,shape,cmd.args)
## FIXME! To add check for xflag?
                context.line_to(shape.xform1d.ex-x+locx,-shape.xform1d.ey-locy+y)
            else:
                for j in range(len(shape.geom.cmds)):
                    cmd = shape.geom.cmds[j]
                    draw.drawcmd[cmd.type](context,shape,cmd.args)
            xe,ye = context.get_current_point()
            if math.fabs(xs-xe)<0.1 and math.fabs(ys-ye)<0.1:
                context.close_path()
            if shape.geom.nofill == 0:
                context.set_source_rgba(fgcolor.r/255.0,fgcolor.g/255.0,fgcolor.b/255.0,fgcolor.a)
                context.fill_preserve()
            if shape.geom.noline == 0:
                context.set_source_rgba(lineclr.r/255.0,lineclr.g/255.0,lineclr.b/255.0,1)
                context.stroke()

def group(doc,page,shape,context,xflag):
        if shape.Foreign.stflag == 0:
            context.save()
            for i in range(len(shape.ShapeList)):
                context.save()
                draw.render3(doc,page,page.shapes[shape.ShapeList[i]],context,2)
                context.restore()
            context.restore()
        else:
            Stencil = doc.stmap[shape.Foreign.Stencil]
            if len(shape.Foreign.List):
                context.save()
                for i in range(len(shape.ShapeList)):
                    try:
                        idx = shape.Foreign.List[i]
                        if page.shapes[shape.ShapeList[i]].fill.set == 0:
                            page.shapes[shape.ShapeList[i]].fill = doc.stencils[Stencil-1].shapes[idx].fill
                            page.shapes[shape.ShapeList[i]].geom.nofill = doc.stencils[Stencil-1].shapes[idx].geom.nofill
                            page.shapes[shape.ShapeList[i]].geom.noline = doc.stencils[Stencil-1].shapes[idx].geom.noline
                            page.shapes[shape.ShapeList[i]].geom.noshow = doc.stencils[Stencil-1].shapes[idx].geom.noshow
                            page.shapes[shape.ShapeList[i]].geom.nosnap = doc.stencils[Stencil-1].shapes[idx].geom.nosnap
                        if len(page.shapes[shape.ShapeList[i]].geom.cmds)==0:
                            page.shapes[shape.ShapeList[i]].geom.cmds=doc.stencils[Stencil-1].shapes[idx].geom.cmds
                        if page.shapes[shape.ShapeList[i]].text.txt == '':
                            page.shapes[shape.ShapeList[i]].text =doc.stencils[Stencil-1].shapes[idx].text
                    except:
                        print 'Fill copying failed'
                    try:
                        if len(page.shapes[shape.ShapeList[i]].Foreign.Data) == 0: 
                            page.shapes[shape.ShapeList[i]].Foreign.Data = doc.stencils[Stencil-1].shapes[0].Foreign.Data
                    except:
                        print 'Foreign data copying failed'
                    context.save()
                    draw.render3(doc,page,page.shapes[shape.ShapeList[i]],context,2)
                    context.restore()
                context.restore()
            else: 
                    context.save()
                    draw.render3(doc,page,doc.stencils[Stencil-1].shapes[0],context,2)
                    context.restore()
                    
def foreign(doc,page,shape,context,xflag):
        if shape.Foreign.stflag != 0:
            Stencil = doc.stmap[shape.Foreign.Stencil]
            if len(shape.Foreign.Data) == 0: 
                shape.Foreign.Data = doc.stencils[Stencil-1].shapes[0].Foreign.Data
        frgn_draw(context,shape,doc.version)
                    
def text(doc,page,shape,context,xflag):
        context.translate(shape.text.txtxform.x,shape.text.txtxform.y)
        charclr = shape.char.charclr
        h = shape.xform.h
        w = shape.xform.w
        layout = context.create_layout()
        context.set_source_rgba(charclr.r/255.0,charclr.g/255.0,charclr.b/255.0,1)
##        FONT = '%s %s %u'%(doc.fonts[shape.char.fntnum],shape.char.style,shape.char.fntsize)  ## *1024 -- pango units        
        FONT = 'Arial %s %u'%(shape.char.style,shape.char.fntsize)  ## for temporary workaround font substitution problem in ver11 files
        fdesc = pango.FontDescription(FONT)
        if shape.char.funder == 1:
            attrs = pango.AttrList()
            attr = pango.AttrUnderline(pango.UNDERLINE_SINGLE,0,len(shape.text.txt))
            attrs.insert(attr)
            layout.set_attributes(attrs)
        layout.set_font_description(fdesc)
        layout.set_alignment(shape.text.para.HAlign)
        layout.set_text(shape.text.txt)
        layout.set_width(int(w*1024))
        
        if shape.text.txtblock.VAlign == 0:
            context.move_to(0,-h)
        if shape.text.txtblock.VAlign == 1:
            context.move_to(0,-layout.get_size()[1]/2048-h/2)
        if shape.text.txtblock.VAlign == 2:
            context.move_to(0,layout.get_size()[1]/2048-h/2)
        context.show_layout(layout)
