# This program was made as part of the sk1project activity to improve UniConvertor
# See http://www.sk1project.org
#
# The code of vsview based on the results of the ALT Linux vsdump project.
# See www.altlinux.ru and http://freshmeat.net/projects/vsdump
#
# Copyright (C) 2007,	Valek Filippov (frob@df.ru)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 3 or later of the GNU General Public
# License as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
# USA

import vsdoc
import struct
import cmd
import chunks

def search(doc,psiter):
    num = 0
    for i in range(doc.model.iter_n_children(psiter)):
        child = doc.model.iter_nth_child(psiter,i)        
        childptr = doc.model.get_value(child,0)["pointer"]
        if childptr.type == 0x15:
            print 'Page %x was found.---------------------------------------------------------------'%num
            page = vsdoc.page()
            doc.pages.append(page)
            parse(doc,child,num)
            num+=1
            
    for i in range(doc.model.iter_n_children(psiter)):
        child = doc.model.iter_nth_child(psiter,i)        
        childptr = doc.model.get_value(child,0)["pointer"]
        if childptr.type == 0xc9:
            offset=0
            if childptr.format&2==2:
                offset=4
            pagenum=ord(childptr.data[offset]) 
            for j in range (pagenum):
                namenum = ord(childptr.data[4+offset+j*13]) 
##                print 'Name idx for page %x is %x.'%(j+1,namenum)
                doc.pages[j].nameidx = namenum
                
    return

##---------------------------------------------------##

def parse(doc,iter,pagenum):
    pntr = doc.model.get_value(iter,0)["pointer"]
    chunks.chunk_parse(doc,pntr)
    if doc.version>5:
        parse_sub(doc,iter,pagenum)
    
def parse_sub(doc,iter,pagenum):    
    for i in range(doc.model.iter_n_children(iter)):
        child = doc.model.iter_nth_child(iter,i)
        childptr = doc.model.get_value(child,0)["pointer"]
        type = ord(childptr.data[0])
        if chunks.chunkfunc.has_key(type):
            chunks.chunkfunc[type](doc,childptr.data,doc.pages[pagenum])
        if doc.model.iter_has_child(child):
            parse_sub(doc,child,pagenum)
    return

