# This program was made as part of the sk1project activity to improve UniConvertor
# See http://www.sk1project.org
#
# The code of vsview based on the results of the ALT Linux vsdump project.
# See www.altlinux.ru and http://freshmeat.net/projects/vsdump
#
# Copyright (C) 2007,	Valek Filippov (frob@df.ru)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of version 3 or later of the GNU General Public
# License as published by the Free Software Foundation.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
# USA

import gtk
import vsdoc
import struct
import cmd
import chunks
import pango
import cairo
##import pangocairo

def search(doc,siter):
    num = 0
    for i in range(doc.model.iter_n_children(siter)): ## 0x1d Stencils
        child = doc.model.iter_nth_child(siter,i)        
        childptr = doc.model.get_value(child,0)["pointer"]
        if childptr.type == 0x1e:
            stencil = vsdoc.stencil()
            doc.stencils.append(stencil)
            doc.stmap[i]=len(doc.stencils)
            parse(doc,child,num)
            num+=1
    if doc.version>5:
        for i in range(doc.model.iter_n_children(siter)):
            child = doc.model.iter_nth_child(siter,i)        
            childptr = doc.model.get_value(child,0)["pointer"]
            if childptr.type == 0xc9:
                offset=0
                if childptr.format&2==2:
                    offset=4
                itemnum=ord(childptr.data[offset]) 
                for j in range (itemnum):
                    namenum = ord(childptr.data[4+offset+j*13]) 
    ##                print 'Name idx for stencil item %x is %x.'%(j,namenum)
                    doc.stencils[j].nameidx = namenum
    return

##---------------------------------------------------##

def parse(doc,iter,stencilnum):
    childpntr = doc.model.get_value(iter,0)["pointer"]  ##0x1e at 1st run
    if childpntr.format>>4 == 0x5 or childpntr.format>>4 == 0x4: 
        type = childpntr.type
        if chunks.chunkfunc.has_key(type):
            if childpntr.format&2 == 2:
                data = '\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'+childpntr.data
            else:
                data = '\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00'+childpntr.data
            chunks.chunkfunc[type](doc,data,doc.stencils[stencilnum])
        if childpntr.format>>4 == 0x5:
            for i in range(doc.model.iter_n_children(iter)):
                grchild = doc.model.iter_nth_child(iter,i)
                parse(doc,grchild,stencilnum)
    if childpntr.format>>4 == 0xd:
        chunks.chunk_parse(doc,childpntr)
        if doc.version>5:
            parse_sub(doc,iter,stencilnum)
    return

def parse_sub(doc,iter,stencilnum):
    for i in range(doc.model.iter_n_children(iter)):
        child = doc.model.iter_nth_child(iter,i)
        childptr = doc.model.get_value(child,0)["pointer"]
        type = ord(childptr.data[0])
        if chunks.chunkfunc.has_key(type):
            chunks.chunkfunc[type](doc,childptr.data,doc.stencils[stencilnum])
        if doc.model.iter_has_child(child):
            parse_sub(doc,child,stencilnum)
    
class sidebar(gtk.DrawingArea):
    def __init__(self,doc):
        self.doc = doc
        self.vsize = 20
        self.hsize = 0
        super(sidebar, self).__init__()
        self.connect("expose_event", self.expose)
        self._dragging = False # true if the interface is being dragged
        for i in range(len(self.doc.stencils)):
            data = str(self.doc.stencils[i].icon)
            pixbufloader = gtk.gdk.PixbufLoader()
            pixbufloader.write(data)
            pixbufloader.close()
            pixbuf = pixbufloader.get_pixbuf()
            imgw=pixbuf.get_width()
            imgh=pixbuf.get_height()
            self.vsize = self.vsize+imgh+15
            if imgw > self.hsize:
                self.hsize = imgw
            wgt = gtk.DrawingArea()
            if self.doc.names.has_key(self.doc.stencils[i].nameidx):
##                print 'i/nameidx/name',i,self.doc.stencils[i].nameidx,self.doc.names[self.doc.stencils[i].nameidx]
                layout = wgt.create_pango_layout(self.doc.names[self.doc.stencils[i].nameidx])
                fdesc = pango.FontDescription("Georgia 8")
                layout.set_font_description(fdesc)
                tsize = layout.get_size()
                if tsize[0]/1024 > self.hsize:
                    self.hsize = tsize[0]/1000
        self.hsize+=40
        self.vsize+=20
        self.set_size_request(self.hsize,self.vsize)

    def expose(self, widget, event):
        self.context = widget.window.cairo_create()
        # set a clip region for the expose event
        self.context.rectangle(event.area.x, event.area.y,event.area.width, event.area.height)
        self.context.clip()
        self.draw(self.context)
        return False

    def draw(self, context):
        context.translate(20,0)
        for i in range(len(self.doc.stencils)):
            data = str(self.doc.stencils[i].icon)
##            f = open('test'+str(i)+'.ico','w')
##            f.write(data)
##            f.close()
            pixbufloader = gtk.gdk.PixbufLoader()
            pixbufloader.write(data)
            pixbufloader.close()
            pixbuf = pixbufloader.get_pixbuf()
            imgh=pixbuf.get_height()
            context.translate(0,imgh)
            ct = gtk.gdk.CairoContext(context)
            ct.set_source_pixbuf(pixbuf,0,0)
            context.paint()
            if self.doc.names.has_key(self.doc.stencils[i].nameidx):
                context.save()
                context.move_to(0,imgh)
                context.set_source_rgb(0,0,0)
                fdesc = pango.FontDescription("Georgia 8")
                layout = context.create_layout()
                layout.set_font_description(fdesc)
                layout.set_text(self.doc.names[self.doc.stencils[i].nameidx])
                context.show_layout(layout)
                context.restore()
                context.translate(0,15)
